//
//  ViewController.m
//  VeryPDFKitDemo
//
//  Created by VeryPDF on 26/3/15.
//  Copyright (c) 2015 VeryPDF.com Inc.. All rights reserved.
//

#import "ViewController.h"
#import <VeryPDFKit/VeryPDFViewController.h>

@interface ViewController ()<VeryPDFViewControllerDelegate>

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)open:(id)sender {
    [self openVeryPDF];
}
- (void)openVeryPDF
{
    //Set your license key at here
    VeryPDFKitSetLicenseCode("XXXX-XXXX-XXXX-XXXX");
    
    NSString *phrase = nil; // Document password (for unlocking most encrypted PDF files)
    NSArray *pdfs = [[NSBundle mainBundle] pathsForResourcesOfType:@"pdf" inDirectory:nil];
    NSString *filePathOriginal = [pdfs firstObject];
    assert(filePathOriginal != nil); // Path to first PDF file
    
    NSError *error;
    NSString *strFilePath = [NSTemporaryDirectory() stringByAppendingPathComponent:@"VeryPDF.pdf"];
    if ([[NSFileManager defaultManager] fileExistsAtPath:strFilePath] == YES)
    {
        [[NSFileManager defaultManager] removeItemAtPath:strFilePath error:&error];
    }
    [[NSFileManager defaultManager] copyItemAtPath:filePathOriginal toPath:strFilePath error:&error];

    VeryPDFDocument *document = [VeryPDFDocument withDocumentFilePath:strFilePath password:phrase];
    
    if (document != nil) // Must have a valid VeryPDFDocument object in order to proceed with things
    {
        VeryPDFViewController *veryPDFViewController = [[VeryPDFViewController alloc] initWithVeryPDFDocument:document];
        
        veryPDFViewController.delegate = self; // Set the VeryPDFViewController delegate to self
        
#if (DEMO_VIEW_CONTROLLER_PUSH == TRUE)
        
        [self.navigationController pushViewController:VeryPDFViewController animated:YES];
        
#else // present in a modal view controller
        
        veryPDFViewController.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
        veryPDFViewController.modalPresentationStyle = UIModalPresentationFullScreen;
        
        [self presentViewController:veryPDFViewController animated:YES completion:NULL];
        
#endif // DEMO_VIEW_CONTROLLER_PUSH
    }
    else // Log an error so that we know that something went wrong
    {
        NSLog(@"%s [VeryPDFDocument withDocumentFilePath:'%@' password:'%@'] failed.", __FUNCTION__, strFilePath, phrase);
    }
}

#pragma mark - VeryPDFViewControllerDelegate methods

- (void)dismissVeryPDFViewController:(VeryPDFViewController *)viewController
{
    // dismiss the modal view controller
    [self dismissViewControllerAnimated:YES completion:NULL];
}

- (void)VeryPDFViewControllerGetFlattenPDF:(VeryPDFViewController *)viewController FlattenPDFFile:(NSString *)strFlattenPDFFile
{
    NSLog(@"Enter VeryPDFViewControllerGetFlattenPDF");
    if(strFlattenPDFFile == nil)
        return;
    if (![[NSFileManager defaultManager] fileExistsAtPath:strFlattenPDFFile])     //Does file exist?
        return;
    NSLog(@"VeryPDFViewControllerGetFlattenPDF: strFlattenPDFFile=%@", strFlattenPDFFile);
    [self ViewPDFFile:strFlattenPDFFile];
    NSLog(@"Exit VeryPDFViewControllerGetFlattenPDF");
}

-(void)ViewPDFFile:(NSString*)strPDFFile
{
    NSURL *URL = [NSURL fileURLWithPath:strPDFFile];
    
    if (URL)
    {
        NSLog(@"ViewPDFFile : %@", URL);
        
        // Initialize Document Interaction Controller
        self.documentInteractionController = [UIDocumentInteractionController interactionControllerWithURL:URL];
        
        // Configure Document Interaction Controller
        [self.documentInteractionController setDelegate:self];
        
        // Preview PDF
        [self.documentInteractionController presentPreviewAnimated:NO];
    }
}
- (UIViewController *) documentInteractionControllerViewControllerForPreview: (UIDocumentInteractionController *) controller
{
    return self;
}

@end
